(defvar *dkeymap* (make-keymap "dkeymap"))
(define-key *dkeymap*
  "C-r" 'load-init-file
  "x" 'delete-current-buffer
  "b" 'switch-buffer)

;;; Search engines
(defvar *my-search-engines*
  (list
   '("kagi" "https://kagi.com/search?q=~a" "https://kagi.com/")))

;;; See: https://github.com/atlas-engineer/nyxt/issues/447
(define-mode my-mode ()
  "Dummy mode for my own keybindings"
  ((keymap-scheme (keymap:make-scheme
                   scheme:cua *dkeymap*
                   scheme:emacs *dkeymap*		   
		   scheme:vi-normal *dkeymap*))))

(define-configuration (buffer web-buffer)
    ;;;((default-modes (append '(vi-normal-mode) %slot-default%))))
    ((default-modes (append '(vi-normal-mode) %slot-default%))))

(define-configuration buffer
    ((search-engines (append %slot-default%
                           (mapcar (lambda (engine) (apply 'make-search-engine engine))
                                   *my-search-engines*)))))
